#include "xmlprefshandler.h"

XmlPrefsHandler::XmlPrefsHandler(Kimo2chPrefs	*prefs)
{
	prefsRef = prefs;
	qDebug() << prefsRef->columnWidth;
}

bool	XmlPrefsHandler::startElement(const QString&, const QString&, const QString &qName, const QXmlAttributes&)
{
	itemName = qName;
	return	true;
}

bool	XmlPrefsHandler::characters(const QString	&ch)
{
//	qDebug() << itemName << ch << endl;
	if(itemName == "initialName")
	{
		prefsRef->initialName = ch;
	}
	else if(itemName == "initialMail")
	{
		prefsRef->initialMail = ch;
	}
	else if(itemName == "defaultSage")
	{
		prefsRef->defaultSage = (ch == "true") ? true : false;
	}
	else if(itemName == "browserFontFamily")
	{
		prefsRef->browserFontFamily = ch;
	}
	else if(itemName == "browserFontSize")
	{
		prefsRef->browserFontSize = ch.toInt();
	}
	else if(itemName == "windowHeight")
	{
		prefsRef->windowHeight = ch.toInt();
	}
	else if(itemName == "windowWidth")
	{
		prefsRef->windowWidth = ch.toInt();
	}
	else if(itemName == "boardURL")
	{
		prefsRef->boardListURL = ch;
	}
	else if(itemName == "columnWidth")
	{
		prefsRef->columnWidth.append(ch.toInt() > 0 ? ch.toInt() : 100);
	}
	else if(itemName == "sessionURL")
	{
		prefsRef->sessionURLs.append(ch);
	}
	itemName = "";
	return	true;
}
