#ifndef __CP932CODEC_H__
#define __CP932CODEC_H__

#include <QtCore>
#include <QTextCodec>
#include <iconv.h>
#include <errno.h>

// place your code here

const QString	TARGETCODE = "CP932";
const QString	APPCODE = "UTF-8";

class	CP932Codec : public	QTextCodec
{
protected:
	CP932Codec();
	virtual	~CP932Codec();
	virtual	QByteArray	convertFromUnicode(const QChar	*input, int	number, ConverterState	*state)	const;
	virtual	QString	convertToUnicode(const	char	*chars, int	len, ConverterState	*state) const;
public:
	virtual	int	mibEnum() const	{ return	2024; }
	virtual	QByteArray	name() const	{ return	"Windows-31J"; }
	static	QTextCodec	*codecForMib(int	mib);// { if(mib == 2024)return	((codec) ? codec : new	CP932Codec()); QTextCodec::codecForMib(mib); }
	static	QTextCodec	*codecForName(const char	*name);// { if(strncmp(name, "Windows-31J", 11)) return	((codec) ? codec : new CP932Codec()); QTextCodec::codecForName(name); }
private:
	iconv_t	fromcd;	// Translate descriptor from unicode
	iconv_t	tocd;	// Translate descriptor to unicode
	CP932Codec	*codec;
};

#endif // __CP932CODEC_H__
