#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#include "qstring.h"
#include <QList>

// Application constants

const QString	APPNAME = "kimo2ch";
const QString	RESOURCEDIR = "/usr/share/" + APPNAME + "/";
const QString	userAgent = "Monazilla/1.0";
const QString	POSTCGI = "test/bbs.cgi";

// File names
const	QString	PREFSFILENAME = "." + APPNAME + ".rc";
const	QString	ABONEFILENAME = "kimo2chAbone.xml";
const	QString	FAVORITESFILENAME = APPNAME + "Favorites.xml";
const	QString	BBSMENUFILENAME = "bbsmenu.html";

// Server response labels

const QString	SUBMITLABEL = QString::fromUtf8("書き込む");
const QString	COOKIEACCEPTLABEL = QString::fromUtf8("上記全てを承諾して書き込む");
const QString	POSTCOMPLETE = QString::fromUtf8("書きこみが終わりました");
const QString	SERVERBUSY = QString::fromUtf8("お茶でも");
const QString	SERVERERROR = QString::fromUtf8("ＥＲＲＯＲ");
const QString	COOKIECONFIRM = QString::fromUtf8("書き込み確認");

// Text constants
const QString	ABONETEXT = QString::fromUtf8("あぼーん");

// Initial preferences

const QString	initialBoardListURL = "http://menu.2ch.net/bbsmenu.html";

const int 	rowHeight = 16;

enum threadColumn
{
	urlCol = 0,
	subjectCol,
	countCol,
	newCol
};

// Buffer size
const	int	CACHESIZE = 512 * 1024;

// #define	QT_CP932_SUPPORT
#define	ICONVBUFSIZE	512*1024*2	// iconv buffer suze for convert Shift_JIS to UTF-8

// Abone data
typedef	struct	aboneData
{
	QStringList	aboneWordList;
	QHash<QString, bool>	aboneId;
	QHash<QString, bool>	aboneName;
	QHash<QString, bool>	aboneMail;
} aboneData;

#endif // __GLOBALS_H__
