#ifndef __KIMO2CHTEXTBROWSER_H__
#define __KIMO2CHTEXTBROWSER_H__

#include <QtGui>
#include "resparser.h"
//#include "src/mainwindowimpl.h"
#include "src/xmlprefshandler.h"

class	ParserThread;

class	Kimo2chTextBrowser : public	QTextBrowser
{
Q_OBJECT
public:
	Kimo2chTextBrowser(QWidget	*parent = 0, Kimo2chTextBrowser	*parentPopupWidget = 0);
	virtual	~Kimo2chTextBrowser();
	
	void	setDat(QStringList	dat, int	readedCount);
	void	setDatData(QStringList	datData, QMultiMap<QString, int> map) { datRef = datData; idMap = map; };
	void	setAboneData();
	void	closePopup();
	
public slots:
	void	setFontFamily(const	QString	&fontFamily);
	void	setFontPointSize(qreal	s);
	
signals:
	void	linkClicked(QUrl	link);

private slots:
	void	relayLink(QUrl	link);
	void	copyAnchor();
	void	copyHeadItem();
	void	addAboneId();
	void	addAboneName();
	void	addAboneMail();
	void	setParsedText();
	
protected:
	virtual void	mouseMoveEvent(QMouseEvent	*e);
	virtual void	mouseReleaseEvent(QMouseEvent	*e);
	virtual void	contextMenuEvent(QContextMenuEvent	*e);
	virtual	void	enterEvent(QEvent	*e);
	virtual	void	leaveEvent(QEvent	*e);
	
public:
	static	QString	rewriteAnchor(const QString	text);
	QStringList	*getDatRef()	{ return	&datRef; }
	QMultiMap<QString, int>	*getIdMap()	{ return	&idMap; }
	int	getReadedCount()	{ return	readedCount; }
	void	setParsedText(QString	parsed)	{ parsedText = parsed; }
	
private:
	// Data for viewing
	QStringList	datRef;
	QStringList	datLines;
	QMultiMap<QString, int>	idMap;
	QString	parsedText;
	QString	anchorText;
	QMenu	*cm;		// Context menu
	QWidget		*popup;
	Kimo2chTextBrowser	*parentPopup;
	Kimo2chTextBrowser	*popupBrowser;
	ParserThread	*parserThread;
	int		readedCount;
	bool	isEnterCursor;
	
public:
	// Browser font
	QString	browserFontFamily;
	int	browserFontPointSize;
	
private:
	// Context menu actions
	QAction	*copyURLAction;		// "Copy this link"
	QAction	*copyAction;		// "Copy (item)"
	QAction	*aboneAction;		// "Abone (item) for ..."
	QAction	*aboneIdAction;		// "Abone id for ..."
	QAction	*aboneNameAction;	// "Abone name for ..."
	QAction	*aboneMailAction;	// "Abone mail for ..."
};

class	ParserThread : public	QThread
{
Q_OBJECT
public:
	ParserThread(Kimo2chTextBrowser	*parent);
	
	virtual	void	run();

signals:
	void	parseCompleted();
	
private:
	Kimo2chTextBrowser	*browser;
	QStringList	*datRef;
//	QMultiMap<QString, int>	idMap;
	int	readedCount;
};

#endif // __KIMO2CHTEXTBROWSER_H__
