#ifndef __RESPARSER_H__
#define __RESPARSER_H__

#include <QtCore>
#include <QtXml>
#include "src/globals.h"

/*
	ResParser class
*/
class	ResParser
{
public:
	static QString	parse(const QString	datLine);
	
	static	void	loadAboneFile(QFile	*aboneFile);
	static	void	saveAboneFile(QFile	*aboneFile);
//	void	setAboneData(aboneData	*data);
private:
	static QString	rewriteAnchor(const QString	originalText);
	
public:
//	static aboneData	*abone;
	static	QMap<QString, bool>	aboneName;
	static	QMap<QString, bool>	aboneMail;
	static	QMap<QString, bool>	aboneId;
	static	QMap<QString, bool> aboneWord;
};

/*
	AboneFile
*/
class	AboneFileHandler : public	QXmlDefaultHandler
{
public:
	AboneFileHandler();
	virtual	~AboneFileHandler();
	
	virtual	bool	characters(const QString	&ch);
	virtual	bool	startDocument();
	virtual	bool	endDocument();
	virtual	bool	startElement(const QString	&/*namespaceURI*/, const QString	&/*localNale*/, const QString	&qName, const QXmlAttributes	&atts);
	virtual	bool	endElement(const QString	&, const QString&, const QString	&qName);
	
private:
	QMap<QString, bool>	*targetList;
	bool	itemState;
};

#endif // __RESPARSER_H__
