#include "xmlprefshandler.h"

XmlPrefsHandler::XmlPrefsHandler(Kimo2chPrefs	*prefs)
{
	prefsRef = prefs;
	prefsRef->boardListURL = "";
	prefsRef->rebuildListOnStartup = false;
	prefsRef->browserFontSize = 12;
	prefsRef->defaultSage = true;
	prefsRef->initialMail = "";
	prefsRef->initialName = "";
	prefsRef->isUseProxy = false;
	prefsRef->proxyHost = "";
	prefsRef->proxyPort = 0;
	prefsRef->proxyUser = "";
	prefsRef->proxyPassword = "";
}

bool	XmlPrefsHandler::startElement(const QString&, const QString&, const QString &qName, const QXmlAttributes&)
{
	itemName = qName;
	return	true;
}

bool	XmlPrefsHandler::characters(const QString	&ch)
{
	if(itemName == "boardListURL")
	{
		prefsRef->boardListURL = ch;
	}
	else if(itemName == "buildListOnStartup")
	{
		prefsRef->rebuildListOnStartup = (ch == "true") ? true : false;
	}
	else if(itemName == "initialName")
	{
		prefsRef->initialName = ch;
	}
	else if(itemName == "initialMail")
	{
		prefsRef->initialMail = ch;
	}
	else if(itemName == "defaultSage")
	{
		prefsRef->defaultSage = (ch == "true") ? true : false;
	}
	else if(itemName == "browserFontFamily")
	{
		prefsRef->browserFontFamily = ch;
	}
	else if(itemName == "browserFontSize")
	{
		prefsRef->browserFontSize = ch.toInt();
	}
	else if(itemName == "windowHeight")
	{
		prefsRef->windowHeight = ch.toInt();
	}
	else if(itemName == "windowWidth")
	{
		prefsRef->windowWidth = ch.toInt();
	}
	else if(itemName == "boardURL")
	{
		prefsRef->boardListURL = ch;
	}
	else if(itemName == "columnWidth")
	{
		prefsRef->columnWidth.append(ch.toInt() > 0 ? ch.toInt() : 100);
	}
	else if(itemName == "sessionURL")
	{
		prefsRef->sessionURLs.append(ch);
	}
	else if(itemName == "isUseProxy")
	{
		prefsRef->isUseProxy = (ch == "true") ? true : false;
	}
	else if(itemName == "proxyHost")
	{
		prefsRef->proxyHost = ch;
	}
	else if(itemName == "proxyPort")
	{
		prefsRef->proxyPort = ch.toInt();
	}
	else if(itemName == "proxyUser")
	{
		prefsRef->proxyUser = ch;
	}
	else if(itemName == "proxyPassword")
	{
		prefsRef->proxyPassword = ch;
	}
	itemName = "";
	return	true;
}
